<template>
  <div></div>
</template>

<script>
import { tileLayer } from 'leaflet'

export default {
  name: 'wmslayer',

  props: {
    // The unique identifier of this layer object within the
    // workspace context.
    identifier: {
      type: String,
      required: true
    }
  },

  computed: {
    workspace: {
      get() {
        return this.$parent.workspace
      }
    },

    leafletMap: {
      get() {
        return this.$parent.leafletMap
      }
    },

    leafletPane: {
      get() {
        return this.$parent.leafletPane
      }
    },

    referenceTime: {
      get() {
        return this.$store.state.workspaces[this.workspace].time.referenceTime
      }
    },

    step: {
      get() {
        return this.$store.state.workspaces[this.workspace].time.step
      }
    },

    layer: {
      get() {
        return this.$store.state.workspaces[this.workspace].layers.find(item => item.id === this.identifier)
      }
    },

    layerDefinition: {
      get() {
        return this.$store.state.api.layers.find(item => item.id === this.layer.layerId)
      }
    },

    serviceURL: {
      get() {
        return this.$store.state.api.services.find(item => item.id === this.layerDefiniton.service).url
      }
    },

    layerStatus: {
      get() {
        return this.layer.active
      }
    }
  },

  watch: {
    layerStatus(after) {
      return after ? this.add() : this.remove()
    },

    referenceTime(after) {
      this.layerObject.setParams({
        reference_time: moment.unix(after).format('YYYY-MM-DDTHH:00:00'),
        time: this._computeTimeParameter(after, this.step)
      })
    },

    step(after) {
      this.layerObject.setParams({
        reference_time: moment.unix(this.referenceTime).format('YYYY-MM-DDTHH:00:00'),
        step: this._computeTimeParameter(this.referenceTime, after)
      })
    },
  },

  methods: {
    create() {
      this.layerObject = tileLayer.wms(this.serviceURL, this._getOptions())
      return this.layerStatus ? this.add() : this
    },

    add() {
      this.layerObject.addTo(this.leafletMap)
      return this
    },

    remove() {
      this.layerObject.remove()
      return this
    },

    _getOptions() {
      return {
        tileSize: 512,
        pane: this.leafletPane.name,
        layers: this.layerDefinition.name,
        format: 'image/png',
        version: '1.3.0',
        transparent: true,
        reference_time: moment.unix(this.referenceTime).format('YYYY-MM-DDTHH:00:00'),
        time: this._computeTimeParameter(this.referenceTime, this.step),
      }
    },

    _computeTimeParameter() {
      let hasTimeResolution = this.layerDefinition.time_resolution !== null
      let baseTime = moment.unix(referenceTime).add(step, 'hours')

      return hasTimeResolution
        ? baseTime.format('YYYY-MM-DDTHH:00:00') + '/' + baseTime.clone().add(this.layerDefinition.time_resolution, 'm').format('YYYY-MM-DDTHH:mm:00')
        : baseTime.format('YYYY-MM-DDTHH:00:00')
    }
  }
}
</script>
